#ifndef ENVY_H
#define ENVY_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <Ecore.h>
#include <Ecore_X.h>
#include <Ecore_Evas.h>
#include <Ecore_Data.h>
#include <Ecore_Job.h>
#include <Evas.h>
#include <Edje.h>
#include <Emotion.h>

#include "config.h"

typedef struct _Sub_Srt Sub_Srt;
struct _Sub_Srt 
{
  int id;
  double start;
  double end;
  char *txt; 
/*  Ecore_Strbuf *txt; */
};

typedef struct _Envy Envy;
struct _Envy
{
  Ecore_Evas *ee;
  Evas *evas;
  Evas_Object *bg;
  Evas_Object *video;
  Evas_Object *black_bg;
  Evas_Object *balloon;
  Evas_Object *sub;
  Evas_Object *info;
  
  Ecore_Timer *mouse_timer;
  Ecore_Timer *info_timer;

  Sub_Srt *subs;
  int subs_size;
  double sub_delay;

  unsigned char fullscreen:1;
  unsigned char show_sub:1;

  const char *filename;
  char *dirname;
};

Envy *envy;
void envy_load_subtitle(const char *subfile);
void envy_osdb_process(void *data);

#endif /* ENVY_H */
