#ifndef ENVY_OSDB_H
#define ENVY_OSDB_H

#include <stdint.h>
#include <inttypes.h>
#include <zlib.h>
#include <errno.h>
#include <error.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <limits.h>

#include <xmlrpc-c/base.h>
#include <xmlrpc-c/client.h>

typedef struct _Envy_Osdb Envy_Osdb;
struct _Envy_Osdb
{
  xmlrpc_env env;

  char *server_url;
  uint64_t moviehash;
  unsigned int moviesize;

  char lang[4];
  char *subfilename;
  unsigned char keep_osdb_subfilename:1;

  const char *token;
  const char *SubFileName; //filename from OSDB, I should rename or delete that var
  const char *IDSubtitleFile;
};

unsigned int envy_moviesize_get(Envy_Osdb *eo, const char *filename);
uint64_t     envy_moviehash_get(Envy_Osdb *eo, const char *filename);
Envy_Osdb   *envy_osdb_new(const char *server_url);
int          envy_osdb_login(Envy_Osdb *eo, const char *lang2c);
int          envy_osdb_search(Envy_Osdb *eo, const char *lang3c, uint64_t moviehash, unsigned int moviesize);
int          envy_osdb_download(Envy_Osdb *eo, const char *id_subtitle_file);
int          envy_osdb_logout(Envy_Osdb *eo);
void         envy_osdb_free(Envy_Osdb *eo);

#endif
